【poj】3126 Prime Path(bfs)

来源:互联网 发布:互联网软件开发工资 编辑:程序博客网 时间:2024/06/05 03:45
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033 
1733 
3733 
3739 
3779 
8779 
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
31033 81791373 80171033 1033
Sample Output
67

0

1. 打印素数表

2. 广搜最短路

#include <map>#include <cstdio>#include <cmath>#include <queue>#include <cstring>#include <iostream>#include <algorithm>using namespace std;const int  N  = 10005;typedef struct node{          int num,step;          node(int n,int s){  num = n ,step = s; }}node;bool prime[N];bool vis[N];int getNext(int num,int i,int j)    // 在固定ij 下找下一个合适的数。{          int num_ = num,j_ = j;          while(j--)    num /= 10;          int y = num % 10;          return num_ +  (i-y)*pow(10,j_);   //只要把相关位的变化值加上就好了。}void bfs(int be, int ed){        if(be == ed)        {                printf("0\n");                return;        }        memset(vis,0,sizeof(vis));        queue <node> qu;        node tmp(be,0);        qu.push(tmp);        vis[be] = 1;        while(!qu.empty())        {                tmp = qu.front();                qu.pop();                for(int i = 0; i < 10; i++)                {                        for(int j = 0; j < 4; j++)                        {                                int num_ =  getNext(tmp.num,i,j);                                if(num_ >= 1000&&!prime[num_] && !vis[num_]) //>=1000 判断首位不为0。                                {                                        if(num_ == ed)                                        {                                            printf("%d\n",tmp.step+1);                                            return;                                        }                                        vis[num_] = 1;                                        node nd(num_,tmp.step+1);                                        qu.push(nd);                                }                        }               }        }        printf("Impossible\n");}void getPrime(){      memset(prime,false,sizeof(prime));      for(int i = 2;i <= N; ++i)            if(prime[i] == false)            {                  for(int j = i+i;j <= N; j += i)                       prime[j] = true;            }}int main(){    getPrime();    int t,be,ed;    scanf("%d",&t);    while(t--)    {          scanf("%d%d",&be,&ed);          bfs(be,ed);    }    return 0;}